=== src/Makefile ===
#########################################################################
#
#  This file is part of the Yices SMT Solver.
#  Copyright (C) 2017 SRI International.
#
#  Yices is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Yices is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Yices.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################

#
# src/Makefile
#
# Must be invoked with the following variables set
#
#   YICES_TOP_DIR = top-level directory for Yices
#   YICES_MODE = build mode
#   YICES_MAKE_INCLUDE = configuration file to include
#   YICES_VERSION = full version
#   MAJOR = major version number
#   MINOR = minor version number
#   PATCH_LEVEL = patch level
#   ARCH = architecture (e.g, i686-pc-linux-gnu)
#   POSIXOS = OS (e.g., linux)
#   BUILD = target build director (normally build/$(ARCH)-$(YICES_MODE))
#
# Config variables are imported by including the file
#   $(YICES_TOP_DIR)/$(YICES_MAKE_INCLUDE)
#

SHELL=/bin/sh

ifeq (,$(YICES_TOP_DIR))
 $(error "YICES_TOP_DIR is undefined")
endif

ifeq (,$(YICES_MAKE_INCLUDE))
 $(error "YICES_MAKE_INCLUDE is undefined")
endif

conf=$(YICES_TOP_DIR)/$(YICES_MAKE_INCLUDE)

include $(conf)

#
# Build subdirectories
# --------------------
# build/obj: object files, in a form suitable for the dynamic libraries
#	    (e.g., compiled with option -fPIC)
# build/static_obj: object files compiled in a form suitable for libyices.a
#	    (e.g., compiled without -fPIC)
#
# build/lib: libraries (GMP not included)
# build/bin: binaries (GMP not included)
#
# build/static_lib: libraries (GMP included)
# build/static_bin: binaries linked statically with GMP (and other libraries if possible)
#
# For cygiwn and mingw: we use a third subdirectory to build objects for the
# dll that includes libgmp.a
# build/static_dll_obj
#
objdir := $(BUILD)/obj
libdir := $(BUILD)/lib
bindir := $(BUILD)/bin

static_objdir := $(BUILD)/static_obj
static_libdir := $(BUILD)/static_lib
static_bindir := $(BUILD)/static_bin

static_dll_objdir := $(BUILD)/static_dll_obj

#
# Distribution subdirectory: tarfiles are constructed
# via make binary-distribution or make smt-distribution
#
# In this makefile, we just copy what needs to be included
# in the distribution tarfiles in $(BUILD)/dist or $(BUILD)/static_dist
#
distdir := $(BUILD)/dist
static_distdir := $(BUILD)/static_dist
smt_distdir := $(BUILD)/smt_dist
static_smt_distdir := $(BUILD)/static_smt_dist



#
# SOURCE FILES
#

#
# Source files for the dynamic library (libyices.so)
#
core_src_c := \
	api/context_config.c \
	api/search_parameters.c \
	api/smt_logic_codes.c \
	api/yices_api.c \
	api/yices_error.c \
	api/yices_error_report.c \
	api/yval.c \
	context/assumption_stack.c \
	context/common_conjuncts.c \
	context/conditional_definitions.c \
	context/context.c \
	context/context_simplifier.c \
	context/context_solver.c \
	context/context_statistics.c \
	context/context_utils.c \
	context/divmod_table.c \
	context/eq_abstraction.c \
	context/eq_learner.c \
	context/internalization_table.c \
	context/ite_flattener.c \
	context/pseudo_subst.c \
	context/shared_terms.c \
	context/symmetry_breaking.c \
	exists_forall/ef_client.c \
	exists_forall/ef_analyze.c \
	exists_forall/ef_parameters.c \
	exists_forall/ef_problem.c \
	exists_forall/efsolver.c \
	frontend/smt2/attribute_values.c \
	frontend/yices/yices_lexer.c \
	frontend/yices/yices_parser.c \
	io/concrete_value_printer.c \
	io/model_printer.c \
	io/pretty_printer.c \
	io/reader.c \
	io/simple_printf.c \
	io/term_printer.c \
	io/tracer.c \
	io/type_printer.c \
	io/yices_pp.c \
	io/writer.c \
	model/abstract_values.c \
	model/arith_projection.c \
	model/concrete_values.c \
	model/fresh_value_maker.c \
	model/fun_maps.c \
	model/fun_trees.c \
	model/generalization.c \
	model/literal_collector.c \
	model/map_to_model.c \
	model/model_eval.c \
	model/model_queries.c \
	model/model_support.c \
	model/models.c \
	model/presburger.c \
	model/projection.c \
	model/term_to_val.c \
	model/val_to_term.c \
	mt/yices_locks.c \
	parser_utils/lexer.c \
	parser_utils/parser.c \
	parser_utils/term_stack2.c \
	parser_utils/term_stack_error.c \
	solvers/bv/bit_blaster.c \
	solvers/bv/bv64_intervals.c \
	solvers/bv/bv_atomtable.c \
	solvers/bv/bvconst_hmap.c \
	solvers/bv/bvexp_table.c \
	solvers/bv/bv_intervals.c \
	solvers/bv/bvpoly_compiler.c \
	solvers/bv/bvpoly_dag.c \
	solvers/bv/bvsolver.c \
	solvers/bv/bv_vartable.c \
	solvers/bv/dimacs_printer.c \
	solvers/bv/merge_table.c \
	solvers/bv/remap_table.c \
	solvers/cdcl/delegate.c \
	solvers/cdcl/gates_hash_table.c \
	solvers/cdcl/gates_manager.c \
	solvers/cdcl/new_gates.c \
	solvers/cdcl/new_gate_hash_map.c \
	solvers/cdcl/new_gate_hash_map2.c \
	solvers/cdcl/new_sat_solver.c \
	solvers/cdcl/smt_core.c \
	solvers/cdcl/truth_tables.c \
	solvers/cdcl/wide_truth_tables.c \
	solvers/egraph/composites.c \
	solvers/egraph/diseq_stacks.c \
	solvers/egraph/egraph_assertion_queues.c \
	solvers/egraph/egraph.c \
	solvers/egraph/egraph_explanations.c \
	solvers/egraph/egraph_utils.c \
	solvers/egraph/theory_explanations.c \
	solvers/floyd_warshall/dl_vartable.c \
	solvers/floyd_warshall/idl_floyd_warshall.c \
	solvers/floyd_warshall/rdl_floyd_warshall.c \
	solvers/funs/fun_solver.c \
	solvers/simplex/arith_atomtable.c \
	solvers/simplex/arith_vartable.c \
	solvers/simplex/diophantine_systems.c \
	solvers/simplex/gomory_cuts.c \
	solvers/simplex/integrality_constraints.c \
	solvers/simplex/matrices.c \
	solvers/simplex/offset_equalities.c \
	solvers/simplex/simplex.c \
	terms/balanced_arith_buffers.c \
	terms/bit_expr.c \
	terms/bit_term_conversion.c \
	terms/bv64_interval_abstraction.c \
	terms/bv64_constants.c \
	terms/bv64_polynomials.c \
	terms/bvarith64_buffers.c \
	terms/bvarith64_buffer_terms.c \
	terms/bvarith_buffers.c \
	terms/bvarith_buffer_terms.c \
	terms/bv_constants.c \
	terms/bvfactor_buffers.c \
	terms/bvlogic_buffers.c \
	terms/bvpoly_buffers.c \
	terms/bv_polynomials.c \
	terms/bv_slices.c \
	terms/conditionals.c \
	terms/elim_subst.c \
	terms/extended_rationals.c \
	terms/free_var_collector.c \
	terms/full_subst.c \
	terms/int_rational_hash_maps.c \
	terms/ite_stack.c \
	terms/mpq_aux.c \
	terms/mpq_stores.c \
	terms/poly_buffer.c \
	terms/poly_buffer_terms.c \
	terms/polynomials.c \
	terms/power_products.c \
	terms/pprod_table.c \
	terms/rational_hash_maps.c \
	terms/rationals.c \
	terms/rba_buffer_terms.c \
	terms/renaming_context.c \
	terms/subst_cache.c \
	terms/subst_context.c \
	terms/term_explorer.c \
	terms/term_manager.c \
	terms/terms.c \
	terms/term_sets.c \
	terms/term_substitution.c \
	terms/term_utils.c \
	terms/types.c \
	terms/variable_renaming.c \
	utils/arena.c \
	utils/backtrack_arrays.c \
	utils/backtrack_int_hash_map.c \
	utils/cache.c \
	utils/csets.c \
	utils/cputime.c \
	utils/dep_tables.c \
	utils/gcd.c \
	utils/generic_heap.c \
	utils/hash_functions.c \
	utils/index_vectors.c \
	utils/int_array_hsets.c \
	utils/int_array_sort2.c \
	utils/int_array_sort.c \
	utils/int_bags.c \
	utils/int_bv_sets.c \
	utils/int_harray_store.c \
	utils/int_hash_classes.c \
	utils/int_hash_map2.c \
	utils/int_hash_map.c \
	utils/int_hash_sets.c \
	utils/int_hash_tables.c \
	utils/int_heap2.c \
	utils/int_heap.c \
	utils/int_partitions.c \
	utils/int_powers.c \
	utils/int_queues.c \
	utils/int_stack.c \
	utils/int_vectors.c \
	utils/mark_vectors.c \
	utils/memalloc.c \
	utils/object_stores.c \
	utils/pair_hash_map.c \
	utils/pair_hash_map2.c \
	utils/pointer_vectors.c \
	utils/ptr_array_sort2.c \
	utils/ptr_array_sort.c \
	utils/ptr_hash_classes.c \
	utils/ptr_hash_map.c \
	utils/ptr_heap.c \
	utils/ptr_partitions.c \
	utils/ptr_queues.c \
	utils/ptr_sets.c \
	utils/ptr_sets2.c \
	utils/ptr_stack.c \
	utils/ptr_vectors.c \
	utils/refcount_int_arrays.c \
	utils/refcount_strings.c \
	utils/resize_arrays.c \
	utils/simple_cache.c \
	utils/simple_int_stack.c \
	utils/sparse_arrays.c \
	utils/stable_sort.c \
	utils/string_buffers.c \
	utils/string_utils.c \
	utils/symbol_tables.c \
	utils/tag_map.c \
	utils/tuple_hash_map.c \
	utils/uint_array_sort.c \
	utils/uint_array_sort2.c \
	utils/uint_rbtrees.c \
	utils/use_vectors.c \
	utils/vector_hash_map.c

#
# Optional: mcsat solver
#
mcsat_src_c := \
	mcsat/tracing.c \
	mcsat/solver.c \
	mcsat/variable_db.c \
	mcsat/variable_queue.c \
	mcsat/value.c \
	mcsat/model.c \
	mcsat/trail.c \
	mcsat/conflict.c \
	mcsat/gc.c \
	mcsat/eq/equality_graph.c \
	mcsat/eq/merge_queue.c \
	mcsat/utils/int_mset.c \
	mcsat/utils/int_lset.c \
	mcsat/utils/value_hash_map.c \
	mcsat/utils/value_vector.c \
	mcsat/utils/scope_holder.c \
	mcsat/utils/statistics.c \
	mcsat/utils/substitution.c \
	mcsat/uf/uf_plugin.c \
	mcsat/bool/clause_db.c \
	mcsat/bool/cnf.c \
	mcsat/bool/bcp_watch_manager.c \
	mcsat/bool/bool_plugin.c \
	mcsat/nra/nra_plugin.c \
	mcsat/nra/nra_plugin_internal.c \
	mcsat/nra/nra_plugin_explain.c \
	mcsat/nra/libpoly_utils.c \
	mcsat/nra/poly_constraint.c \
	mcsat/nra/feasible_set_db.c \
	mcsat/ite/ite_plugin.c \
	mcsat/bv/bv_plugin.c \
	mcsat/bv/bv_bdd_manager.c \
	mcsat/bv/bv_evaluator.c \
	mcsat/bv/bv_explainer.c \
	mcsat/bv/bv_feasible_set_db.c \
	mcsat/bv/bdd_computation.c \
	mcsat/bv/explain/arith_utils.c \
	mcsat/bv/explain/arith_norm.c \
	mcsat/bv/explain/arith_intervals.c \
	mcsat/bv/explain/arith.c \
	mcsat/bv/explain/eq_ext_con.c \
	mcsat/bv/explain/full_bv_sat.c \
	mcsat/bv/explain/full_bv_trivial.c \
	mcsat/watch_list_manager.c \
	mcsat/preprocessor.c \
	mcsat/options.c



#
# Fake mcsat module: do nothing. Used to make the compilation go through.
#
no_mcsat_src_c := \
	mcsat/no_mcsat.c \
	mcsat/options.c


#
# Other source files for libyices.a
# That's all the code needed by the main binaries
# + experimental/unfinished modules
# + functions for printing/debugging
# + old stuff not needed anymore (except for tests)
#
extra_src_c := \
	context/context_parameters.c \
	context/context_printer.c \
	context/dump_context.c \
	context/internalization_printer.c \
	frontend/common/assumptions_and_core.c \
	frontend/common/assumption_table.c \
	frontend/common/bug_report.c \
	frontend/common/named_term_stacks.c \
	frontend/common/parameters.c \
	frontend/common/tables.c \
	frontend/smt1/smt_lexer.c \
	frontend/smt1/smt_parser.c \
	frontend/smt1/smt_term_stack.c \
	frontend/smt2/parenthesized_expr.c \
	frontend/smt2/smt2_commands.c \
	frontend/smt2/smt2_expressions.c \
	frontend/smt2/smt2_lexer.c \
	frontend/smt2/smt2_model_printer.c \
	frontend/smt2/smt2_parser.c \
	frontend/smt2/smt2_printer.c \
	frontend/smt2/smt2_symbol_printer.c \
	frontend/smt2/smt2_term_stack.c \
	frontend/smt2/smt2_type_printer.c \
	frontend/yices/arith_solver_codes.c \
	frontend/yices/labeled_assertions.c \
	frontend/yices/yices_help.c \
	frontend/yices/yices_reval.c \
	model/large_bvsets.c \
	model/rb_bvsets.c \
	model/small_bvsets.c \
	scratch/booleq_table.c \
	scratch/bool_vartable.c \
	scratch/update_graph.c \
	solvers/bv/bvsolver_printer.c \
	solvers/cdcl/clause_pool.c \
	solvers/cdcl/gates_printer.c \
	solvers/cdcl/sat_solver.c \
	solvers/cdcl/smt_core_printer.c \
	solvers/egraph/egraph_printer.c \
	solvers/floyd_warshall/idl_fw_printer.c \
	solvers/floyd_warshall/rdl_fw_printer.c \
	solvers/funs/fun_solver_printer.c \
	solvers/simplex/dsolver_printer.c \
	solvers/simplex/int_constraint_printer.c \
	solvers/simplex/simplex_printer.c \
	solvers/simplex/simplex_prop_table.c \
	terms/arith_buffers.c \
	utils/command_line.c \
	utils/memsize.c \
	utils/pair_hash_sets.c \
